<?php
/* Autor...:  */
/* Esquema.: MST_ListaPrecioDetalleLog.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Metodos de acceso a los campos de la tabla MST_ListaPrecioDetalleLog */
abstract class BaseMST_ListaPrecioDetalleLogBN
{
    /* Campos de la tabla */
    private $i_IdLPDLog;    // IdLPDLog: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_IdTipoPrecio;    // IdTipoPrecio: ( no definido )
    private $d_FechaInicio;    // FechaInicio: ( no definido )
    private $d_FechaFin;    // FechaFin: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $f_PrecioCosto;    // PrecioCosto: ( no definido )
    private $f_PorcentajeUtilidad;    // PorcentajeUtilidad: ( no definido )
    private $f_PrecioVenta;    // PrecioVenta: ( no definido )
    private $f_MontoDescuento;    // MontoDescuento: ( no definido )
    private $f_PorcentajeDescuento;    // PorcentajeDescuento: ( no definido )
    private $s_DescuentoFlag;    // DescuentoFlag: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $d_FechaLog;    // FechaLog: ( no definido )
    private $s_UsuarioLog;    // UsuarioLog: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdLPDLog */
    public function setIdLPDLog( $i_IdLPDLog )
    {
        $this->i_IdLPDLog = $i_IdLPDLog;
    }

    /* Obtiene el valor del campo IdLPDLog */
    public function getIdLPDLog()
    {
        return $this->i_IdLPDLog;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo IdTipoPrecio */
    public function setIdTipoPrecio( $s_IdTipoPrecio )
    {
        $this->s_IdTipoPrecio = $s_IdTipoPrecio;
    }

    /* Obtiene el valor del campo IdTipoPrecio */
    public function getIdTipoPrecio()
    {
        return $this->s_IdTipoPrecio;
    }

    /* Establece el valor del campo FechaInicio */
    public function setFechaInicio( $d_FechaInicio )
    {
        $this->d_FechaInicio = $d_FechaInicio;
    }

    /* Obtiene el valor del campo FechaInicio */
    public function getFechaInicio()
    {
        return $this->d_FechaInicio;
    }

    /* Establece el valor del campo FechaFin */
    public function setFechaFin( $d_FechaFin )
    {
        $this->d_FechaFin = $d_FechaFin;
    }

    /* Obtiene el valor del campo FechaFin */
    public function getFechaFin()
    {
        return $this->d_FechaFin;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo PrecioCosto */
    public function setPrecioCosto( $f_PrecioCosto )
    {
        $this->f_PrecioCosto = $f_PrecioCosto;
    }

    /* Obtiene el valor del campo PrecioCosto */
    public function getPrecioCosto()
    {
        return $this->f_PrecioCosto;
    }

    /* Establece el valor del campo PorcentajeUtilidad */
    public function setPorcentajeUtilidad( $f_PorcentajeUtilidad )
    {
        $this->f_PorcentajeUtilidad = $f_PorcentajeUtilidad;
    }

    /* Obtiene el valor del campo PorcentajeUtilidad */
    public function getPorcentajeUtilidad()
    {
        return $this->f_PorcentajeUtilidad;
    }

    /* Establece el valor del campo PrecioVenta */
    public function setPrecioVenta( $f_PrecioVenta )
    {
        $this->f_PrecioVenta = $f_PrecioVenta;
    }

    /* Obtiene el valor del campo PrecioVenta */
    public function getPrecioVenta()
    {
        return $this->f_PrecioVenta;
    }

    /* Establece el valor del campo MontoDescuento */
    public function setMontoDescuento( $f_MontoDescuento )
    {
        $this->f_MontoDescuento = $f_MontoDescuento;
    }

    /* Obtiene el valor del campo MontoDescuento */
    public function getMontoDescuento()
    {
        return $this->f_MontoDescuento;
    }

    /* Establece el valor del campo PorcentajeDescuento */
    public function setPorcentajeDescuento( $f_PorcentajeDescuento )
    {
        $this->f_PorcentajeDescuento = $f_PorcentajeDescuento;
    }

    /* Obtiene el valor del campo PorcentajeDescuento */
    public function getPorcentajeDescuento()
    {
        return $this->f_PorcentajeDescuento;
    }

    /* Establece el valor del campo DescuentoFlag */
    public function setDescuentoFlag( $s_DescuentoFlag )
    {
        $this->s_DescuentoFlag = $s_DescuentoFlag;
    }

    /* Obtiene el valor del campo DescuentoFlag */
    public function getDescuentoFlag()
    {
        return $this->s_DescuentoFlag;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo FechaLog */
    public function setFechaLog( $d_FechaLog )
    {
        $this->d_FechaLog = $d_FechaLog;
    }

    /* Obtiene el valor del campo FechaLog */
    public function getFechaLog()
    {
        return $this->d_FechaLog;
    }

    /* Establece el valor del campo UsuarioLog */
    public function setUsuarioLog( $s_UsuarioLog )
    {
        $this->s_UsuarioLog = $s_UsuarioLog;
    }

    /* Obtiene el valor del campo UsuarioLog */
    public function getUsuarioLog()
    {
        return $this->s_UsuarioLog;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdLPDLog' => $this->getIdLPDLog(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdItem' => $this->getIdItem(),
            'IdTipoPrecio' => $this->getIdTipoPrecio(),
            'FechaInicio' => $this->getFechaInicio(),
            'FechaFin' => $this->getFechaFin(),
            'Estado' => $this->getEstado(),
            'PrecioCosto' => $this->getPrecioCosto(),
            'PorcentajeUtilidad' => $this->getPorcentajeUtilidad(),
            'PrecioVenta' => $this->getPrecioVenta(),
            'MontoDescuento' => $this->getMontoDescuento(),
            'PorcentajeDescuento' => $this->getPorcentajeDescuento(),
            'DescuentoFlag' => $this->getDescuentoFlag(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'FechaLog' => $this->getFechaLog(),
            'UsuarioLog' => $this->getUsuarioLog(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_ListaPrecioDetalleLogBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_ListaPrecioDetalleLogRs )
    {
        $o_MST_ListaPrecioDetalleLogBN = new MST_ListaPrecioDetalleLogBN();
        $o_MST_ListaPrecioDetalleLogBN->setIdLPDLog( ( integer ) $o_MST_ListaPrecioDetalleLogRs[ "IdLPDLog" ] );
        $o_MST_ListaPrecioDetalleLogBN->setIdCompania( ( integer ) $o_MST_ListaPrecioDetalleLogRs[ "IdCompania" ] );
        $o_MST_ListaPrecioDetalleLogBN->setIdSucursal( ( integer ) $o_MST_ListaPrecioDetalleLogRs[ "IdSucursal" ] );
        $o_MST_ListaPrecioDetalleLogBN->setIdItem( $o_MST_ListaPrecioDetalleLogRs[ "IdItem" ] );
        $o_MST_ListaPrecioDetalleLogBN->setIdTipoPrecio( $o_MST_ListaPrecioDetalleLogRs[ "IdTipoPrecio" ] );
        $o_MST_ListaPrecioDetalleLogBN->setFechaInicio( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleLogRs[ "FechaInicio" ], "Y-m-d" ) );
        $o_MST_ListaPrecioDetalleLogBN->setFechaFin( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleLogRs[ "FechaFin" ], "Y-m-d" ) );
        $o_MST_ListaPrecioDetalleLogBN->setEstado( $o_MST_ListaPrecioDetalleLogRs[ "Estado" ] );
        $o_MST_ListaPrecioDetalleLogBN->setPrecioCosto( ( float ) $o_MST_ListaPrecioDetalleLogRs[ "PrecioCosto" ] );
        $o_MST_ListaPrecioDetalleLogBN->setPorcentajeUtilidad( ( float ) $o_MST_ListaPrecioDetalleLogRs[ "PorcentajeUtilidad" ] );
        $o_MST_ListaPrecioDetalleLogBN->setPrecioVenta( ( float ) $o_MST_ListaPrecioDetalleLogRs[ "PrecioVenta" ] );
        $o_MST_ListaPrecioDetalleLogBN->setMontoDescuento( ( float ) $o_MST_ListaPrecioDetalleLogRs[ "MontoDescuento" ] );
        $o_MST_ListaPrecioDetalleLogBN->setPorcentajeDescuento( ( float ) $o_MST_ListaPrecioDetalleLogRs[ "PorcentajeDescuento" ] );
        $o_MST_ListaPrecioDetalleLogBN->setDescuentoFlag( $o_MST_ListaPrecioDetalleLogRs[ "DescuentoFlag" ] );
        $o_MST_ListaPrecioDetalleLogBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleLogRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ListaPrecioDetalleLogBN->setUsuarioCreacion( $o_MST_ListaPrecioDetalleLogRs[ "UsuarioCreacion" ] );
        $o_MST_ListaPrecioDetalleLogBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleLogRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ListaPrecioDetalleLogBN->setFechaLog( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleLogRs[ "FechaLog" ], "Y-m-d H:i:s" ) );
        $o_MST_ListaPrecioDetalleLogBN->setUsuarioLog( $o_MST_ListaPrecioDetalleLogRs[ "UsuarioLog" ] );
        $o_MST_ListaPrecioDetalleLogBN->setUsuarioModificacion( $o_MST_ListaPrecioDetalleLogRs[ "UsuarioModificacion" ] );
        return $o_MST_ListaPrecioDetalleLogBN;
    }
}
?>